# Class VaspPoscarReader

java.lang.Object
org.jmol.adapter.smarter.AtomSetCollectionReader
org.jmol.adapter.readers.xtal.VaspPoscarReader

All Implemented Interfaces:
  `GenericLineReader`

Direct Known Subclasses:
  `AFLOWReader, VaspChgcarReader`

public class VaspPoscarReader extends AtomSetCollectionReader
adjusted for AFLOW options - adding element names, environment radius on atom line http://cms.mpi.univie.ac.at/vasp/

Version:
  1.0
Author:
  Pieremanuele Canepa, Wake Forest University, Department of Physics Winston Salem, NC 27106, canepap@wfu.edu (pcanepa@mit.edu), Bob Hanson

## Field Summary

Fields
Modifier and Type
Field
Description
`protected int`
`ac`
`protected Lst<String>`
`atomLabels`
`protected String[]`
`defaultLabels`
`protected String[]`
`elementLabel`
`protected boolean`
`quiet`
`protected String`
`title`

### Fields inherited from class AtomSetCollectionReader

`addedData, addedDataKey, addVibrations, allow_a_len_1, allowPDBFilter, ANGSTROMS_PER_BOHR, applySymmetryToBonds, asc, baseAtomIndex, baseBondIndex, binaryDoc, bsFilter, bsModels, calculationType, CELL_TYPE_CONVENTIONAL, CELL_TYPE_PRIMITIVE, CELL_TYPE_SUPER, cellSlop, centroidPacked, checkNearAtoms, continuing, debugging, desiredModelNumber, desiredSpaceGroupIndex, desiredVibrationNumber, doApplySymmetry, doCentralize, doCentroidUnitCell, doCheckUnitCell, doConvertToFractional, doPackUnitCell, doProcessLines, doReadMolecularOrbitals, dssr, fileName, fileOffset, filePath, fileScaling, fillRange, filter, filterAllHetero, filterCased, filteredPrecision, filterHetero, floatifyJavaDouble, forcePacked, getHeader, haveAtomFilter, haveModel, havePartialChargeFilter, htParams, ignoreFileSpaceGroupName, ignoreFileSymmetryOperators, ignoreFileUnitCell, ignoreStructure, iHaveFractionalCoordinates, iHaveSymmetryOperators, iHaveUnitCell, is2D, isBinary, isConcatenated, isDSSP1, isFinalized, isMolecular, isPrimitive, isSequential, isSUPERCELL, isTrajectory, latticeCells, latticeScaling, latticeType, line, lowPrecision, lstNCS, matUnitCellOrientation, merging, modDim, modelNumber, ms, mustFinalizeModelSet, next, noHydrogens, noMinimize, noPack, optimize2D, out, paramsCentroid, paramsLattice, precision, prevline, primitiveToCrystal, ptLine, ptSupercell, reader, readerName, requiresBSFilter, reverseModels, rotateHexCell, sgName, slabXY, stateScriptVersionInt, strSupercell, symmetry, templateAtomCount, thisBiomolecule, trajectorySteps, ucItems, unitCellOffset, unitCellParams, useAltNames, useFileModelNumbers, validation, vibrationNumber, vibsFractional, vwr`

## Constructor Summary

Constructors
Constructor
Description
`VaspPoscarReader()`

## Method Summary

Modifier and Type
Method
Description
`protected void`
`finalizeSubclassReader()`
`protected String`
`getElement(String token)`
allow for any number of characters, for which the first one or two are an element symbol.
`protected void`
`initializeReader()`
`protected String`
`rdline()`
`protected void`
`readCoordinates()`
`protected void`
`readMolecularFormula()`
try various ways to read the optional atom labels.
`protected void`
`readStructure(String titleMsg)`
`protected void`
`readUnitCellVectors()`

### Methods inherited from class AtomSetCollectionReader

`addAtomXYZSymName, addExplicitLatticeVector, addJmolScript, addMoreUnitCellInfo, addSites, addSiteScript, appendLoadNote, applySymmetryAndSetTrajectory, applySymTrajASCR, checkAndRemoveFilterKey, checkCurrentLineForScript, checkFilterKey, checkLastModel, checkLine, checkLineForScript, clearUnitCell, cloneLastAtomSet, discardLinesUntilBlank, discardLinesUntilContains, discardLinesUntilContains2, discardLinesUntilNonBlank, discardLinesUntilStartsWith, discardPreviousAtoms, doGetModel, doGetVibration, doPreSymmetry, fill3x3, fillDataBlock, fillDataBlockFixed, fillFloatArray, fillFrequencyData, filterAtom, filterReject, finalizeMOData, finalizeModelSet, finalizeReaderASCR, finalizeSubclassSymmetry, fixDoubleA, fixFloatA, fixFloatPt, forceSymmetry, fractionalizeCoordinates, getElementSymbol, getFilter, getFilterWithCase, getFortranFormatLengths, getInterface, getPackingRangeValue, getStrings, getSymmetry, getTokens, getTokensFloat, initializeSymmetry, initializeSymmetryOptions, initializeTrajectoryFile, isLastModel, newAtomSet, parseFloat, parseFloatRange, parseFloatStr, parseInt, parseIntAt, parseIntRange, parseIntStr, parsePrecision, parseToken, parseTokenNext, parseTokenRange, parseTokenStr, processBinaryDocument, processDOM, rd, read3Vectors, readDataObject, readLines, readNextLine, rejectAtomName, RL, set2D, setAtomCoord, setAtomCoordScaled, setAtomCoordTokens, setAtomCoordXYZ, setChainID, setElementAndIsotope, setFilter, setFilterAtomTypeStr, setFractionalCoordinates, setIsPDB, setLoadNote, setModelPDB, setPrecision, setSpaceGroupName, setSymmetryOperator, setTransform, setUnitCell, setUnitCellItem, setup, setupASCR, warnSkippingOperation`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### atomLabels

protected Lst<String> atomLabels

### ac

protected int ac

### title

protected String title

### quiet

protected boolean quiet

### defaultLabels

protected String[] defaultLabels

### elementLabel

protected String[] elementLabel

## Constructor Details

### VaspPoscarReader

public VaspPoscarReader()

## Method Details

### initializeReader

protected void initializeReader() throws Exception

Overrides:
  `initializeReader` in class `AtomSetCollectionReader`
Throws:
  `Exception`

### readStructure

protected void readStructure(String titleMsg) throws Exception

Throws:
  `Exception`

### finalizeSubclassReader

protected void finalizeSubclassReader() throws Exception

Overrides:
  `finalizeSubclassReader` in class `AtomSetCollectionReader`
Throws:
  `Exception`

### readUnitCellVectors

protected void readUnitCellVectors() throws Exception

Throws:
  `Exception`

### readMolecularFormula

protected void readMolecularFormula() throws Exception
try various ways to read the optional atom labels. There is no convention here.

Throws:
  `Exception`

### readCoordinates

protected void readCoordinates() throws Exception

Throws:
  `Exception`

### getElement

protected String getElement(String token)
allow for any number of characters, for which the first one or two are an element symbol.

Parameters:
  `token` -
Returns:
  element symbol

### rdline

protected String rdline() throws Exception

Throws:
  `Exception`